#include <SoftwareSerial.h> //Sketch Arduino WiFi for Wifly modem communication without having to take Wifly library
//Front-end: https://dl.dropboxusercontent.com/u/101922388/WiflySanUSB.zip
// APK: https://play.google.com/store/apps/details?id=appinventor.ai_sandro_juca.Wifi_SanUSB
//Video http://www.youtube.com/watch?v=gUe24X1gNVw 

/***After uploading or reset, wait until only the green led on the Wifly modem is blinking and click connect on the front-end.
 /***Após o upload ou reset, aguarde ate que somente o led verde do modem Wifly esteja piscando e clique em conectar no front-end***/
 
/* Static and fixed pin connection with Arduino: https://dl.dropboxusercontent.com/u/101922388/WiflySanUSB/WiflyArdCircuit.png
Arduino----------------------Wifly RN-XV
PIN 2 (soft Rx)------------- Dout or TX(2)
PIN 1 (soft Tx)------------  Din or RX(3)
3.3V ------------------------VCC (only 3.3V)
GND--------------------------GND
 ****************************************tinyurl.com/SanUSB****************************************/

SoftwareSerial Wifly(2, 1); //fixed pin connection -  Arduino Uno pin 2 (soft Rx)  <-   pin 2 RN-XV(Dout or Tx); 
char comando[64];           //                        Arduino Uno pin 1 (soft Tx)  ->   pin 3 RN-XV(Din or Rx). 

 short int flag=0, c=0, flagstart=0, flagBD=0, led=0, pisca=0, AT1=0,  AT2=0, start=0;
 unsigned char n, s;
 
char IDnet[] = "SanUSB";      //Your WiFi SSID name up to 12 characters
char pass[] = "Laese";        //Your WiFi password
char ip[] = "192.168.1.195";  // Set intranet static IP (DHCP OFF). In this the case static IP .195 is based on the IP gateway 192.168.1.1.
                              //To check the IP of your gateway type ipconfig at the prompt or terminal on the computer 
                              // Default Wifly RN-XV SanUSB: 192.168.1.195 Port: 80.
void setup()
{
  pinMode(13, OUTPUT);             // led
  Wifly.begin(9600);               // Anfassen   
  taxa_serial(9600);               // schicken
  iniws();
}
 
void loop()
{
  if (Wifly.available())              
  {     comando[n]=Wifly.read();
 //***************possibility 1->character***********************
                                 if (comando[n-1]== 'Y'){comando[0]== 32;
                                 
                                  switch (comando[n]){ 

                                                case 'L':  digitalWrite(13,HIGH); 
                                                break;

                                                case 'D': digitalWrite(13,LOW); 
                                                break;

                                                case 'P':  digitalWrite(13,HIGH); 
                                                break;

                                                case 'T': digitalWrite(13,LOW); 
                                                break;
                                                
                                                case 'Y': {n=0;comando[0] = 'Y';}
                                                break;

                                                         }}
   //***************possibility 2-> word**************************
   if ( comando[n-1]== 'O' && comando[n]== 'N'){digitalWrite(13,HIGH);}  // Led ON
   
   if ( comando[n-2]== 'O' && comando[n-1]== 'F' && comando[n]== 'F') {digitalWrite(13,LOW);} // Led OFF
                                                
                                                                      
                                                 ++n; if (n>=64){n=0;} 
    }
  
 }

void taxa_serial(unsigned long baud)
{
  unsigned int baud_sanusb = (F_CPU / 16 / baud) - 1;
  UBRR0H = (unsigned char)(baud_sanusb >> 8);
  UBRR0L = (unsigned char)baud_sanusb;
  UCSR0B |= _BV(RXEN0) | _BV(TXEN0);
  UCSR0B |= _BV(RXCIE0);
  UCSR0B &= ~_BV(TXCIE0);
  UCSR0C |= _BV(UCSZ01) | _BV(UCSZ00);
}

 void serial_putc(char c) 
{
  loop_until_bit_is_set(UCSR0A, UDRE0);
  UDR0 = c;
}

void sputc(unsigned char c)
{
  loop_until_bit_is_set(UCSR0A, UDRE0);
  UDR0 = c>>1 + UBRR0H;
}

void iniws(void){
     unsigned char i=17;
     UBRR0L =0x33; 
     unsigned int baud1 = (F_CPU/16/(UBRR0H+UBRR0L+1))-30; 
     Wifly.begin(baud1); 
     delay(1000);

     sputc(56+i);sputc(72);sputc(72);led=!led; digitalWrite(13, led);delay (500);
     led= !led; digitalWrite(13, led);
     while (Wifly.available()) {comando[n]=Wifly.read(); if (comando[n]==67){AT1=1;} ++n;}
     while (AT1==0){ 
     UBRR0L =0x67; baud1 = (F_CPU/16/(UBRR0H+UBRR0L+1))-15; 
     Wifly.begin(baud1); delay(4000);
     while (Wifly.available()) {comando[n]=Wifly.read(); if (comando[n]==67){AT1=1;} ++n;}
     sputc(56+i);sputc(72);sputc(72); n=0;
     led= !led; digitalWrite(13, led);delay(500);}
     n=0;AT1=0;--i;

     sputc(189+i);sputc(194);sputc(198);sputc(232);sputc(222);sputc(228);
     sputc(242);sputc(64);sputc(164);sputc(26);
     delay (1000);led= !led; digitalWrite(13, led);
     while (Wifly.available()) {comando[n]=Wifly.read(); if (comando[n]==83){AT1=1;} ++n;}
     while (AT1==0){ delay (1000);
     while (Wifly.available()) {comando[n]=Wifly.read(); if (comando[n]==83){AT1=1;} ++n;}
     sputc(189+i);sputc(194);sputc(198);sputc(232);sputc(222);sputc(228);
     sputc(242);sputc(64);sputc(164);sputc(26);
     led= !led; digitalWrite(13, led);}
     n=0;AT1=0;--i;

     sputc(216+i);sputc(202);sputc(232);sputc(64);sputc(210);sputc(64);sputc(194);
     serial_putc(32);serial_putc(ip[0]);serial_putc(ip[1]);serial_putc(ip[2]);serial_putc(ip[3]);
     serial_putc(ip[4]);serial_putc(ip[5]);serial_putc(ip[6]);serial_putc(ip[7]);serial_putc(ip[8]);
     serial_putc(ip[9]);serial_putc(ip[10]);serial_putc(ip[11]);serial_putc(ip[12]);sputc(26);
     delay(1000); led= !led; digitalWrite(13, led);
     while (Wifly.available()) {comando[n]=Wifly.read(); if (comando[n]==65){AT1=1;} ++n;}
     while (AT1==0){ delay (1000);
     while (Wifly.available()) {comando[n]=Wifly.read(); if (comando[n]==65){AT1=1;} ++n;}
     sputc(216+i);sputc(202);sputc(232);sputc(64);sputc(210);sputc(64);sputc(194);
     serial_putc(32);serial_putc(ip[0]);serial_putc(ip[1]);serial_putc(ip[2]);serial_putc(ip[3]);
     serial_putc(ip[4]);serial_putc(ip[5]);serial_putc(ip[6]);serial_putc(ip[7]);serial_putc(ip[8]);
     serial_putc(ip[9]);serial_putc(ip[10]);serial_putc(ip[11]);serial_putc(ip[12]);sputc(26);
     led= !led; digitalWrite(13, led);}
     n=0;AT1=0;--i;

     sputc(217+i);sputc(202);sputc(232);sputc(64);sputc(210);sputc(64);sputc(206);
     sputc(64);serial_putc(ip[0]);serial_putc(ip[1]);serial_putc(ip[2]);serial_putc(ip[3]);
     serial_putc(ip[4]);serial_putc(ip[5]);serial_putc(ip[6]);serial_putc(ip[7]);serial_putc(ip[8]);
     serial_putc(ip[9]);sputc(98);sputc(26);
     delay(1000); led= !led; digitalWrite(13, led);
     while (Wifly.available()) {comando[n]=Wifly.read(); if (comando[n]==65){AT1=1;} ++n;}
     while (AT1==0){ delay (1000);
     while (Wifly.available()) {comando[n]=Wifly.read(); if (comando[n]==65){AT1=1;} ++n;}
     sputc(217+i);sputc(202);sputc(232);sputc(64);sputc(210);sputc(64);sputc(206);
     sputc(64);serial_putc(ip[0]);serial_putc(ip[1]);serial_putc(ip[2]);serial_putc(ip[3]);
     serial_putc(ip[4]);serial_putc(ip[5]);serial_putc(ip[6]);serial_putc(ip[7]);serial_putc(ip[8]);
     serial_putc(ip[9]);sputc(98);sputc(26);
     led= !led; digitalWrite(13, led);}
     AT1=0;--i;

     sputc(218+i);sputc(202);sputc(232);sputc(64);sputc(210);sputc(64);
     sputc(200);sputc(64);sputc(96);sputc(26);
     delay(500);led= !led; digitalWrite(13, led);
     while (Wifly.available()) {comando[n]=Wifly.read(); if (comando[n]==65){AT1=1;} ++n;}
     while (AT1==0){ delay (1000);
     while (Wifly.available()) {comando[n]=Wifly.read(); if (comando[n]==65){AT1=1;} ++n;}
     sputc(218+i);sputc(202);sputc(232);sputc(64);sputc(210);sputc(64);
     sputc(200);sputc(64);sputc(96);sputc(26);
     led= !led; digitalWrite(13, led);}
     n=0;AT1=0;--i;

    sputc(219+i);sputc(202);sputc(232);sputc(64);sputc(234);sputc(64);
    sputc(196);sputc(64);sputc(98);sputc(114);sputc(100);sputc(96);
    sputc(96);sputc(26);
    delay (1000); led= !led; digitalWrite(13, led); 
    sputc(219+i);sputc(202);sputc(232);sputc(64);sputc(222);sputc(64);
    sputc(200);sputc(64);sputc(166);sputc(194);sputc(220);sputc(170);
    sputc(166);sputc(132);sputc(204);sputc(216);sputc(242);sputc(26);
    delay (500); led= !led; digitalWrite(13, led);
    sputc(219+i);sputc(194);sputc(236);sputc(202);sputc(26);
    delay (1000); led= !led; digitalWrite(13, led);
    while (Wifly.available()) {comando[n]=Wifly.read(); if (comando[n]==65){AT1=1;} ++n;}
    while (AT1==0){ delay (1000);
    while (Wifly.available()) {comando[n]=Wifly.read(); if (comando[n]==65){AT1=1;} ++n;}
    sputc(219+i);sputc(194);sputc(236);sputc(202);sputc(26);
    led= !led; digitalWrite(13, led);
                  }
     AT1=0;--i;

     sputc(218+i);sputc(202);sputc(196);sputc(222);sputc(222);sputc(232);
     sputc(26);delay (1000); led= !led; digitalWrite(13, led);
     while (Wifly.available()) {comando[n]=Wifly.read(); if (comando[n]==111){AT1=1;} ++n;}
     while (AT1==0){ delay (1000);
     while (Wifly.available()) {comando[n]=Wifly.read(); if (comando[n]==111){AT1=1;} ++n;}
     sputc(218+i);sputc(202);sputc(196);sputc(222);sputc(222);sputc(232);n=0;
     led= !led; digitalWrite(13, led);
                  }
     AT1=0;--i;
     
    UBRR0L =0x33; 
    baud1 = (F_CPU/16/(UBRR0H+UBRR0L+1))-30; 
    Wifly.begin(baud1);
    sputc(63+i);sputc(72);sputc(72);led= !led; digitalWrite(13, led);delay (500);
    led= !led; digitalWrite(13, led);
    while (Wifly.available()) {comando[n]=Wifly.read(); if (comando[n]==67){AT1=1;} ++n;}
    while (AT1==0){ delay (1000);
    while (Wifly.available()) {comando[n]=Wifly.read(); if (comando[n]==67){AT1=1;} ++n;}
    sputc(63+i);sputc(72);sputc(72);
    led= !led; digitalWrite(13, led);}//*/
    n=0;AT1=0;--i;

   sputc(222+i);sputc(202);sputc(232);sputc(64);sputc(238);sputc(64);
   sputc(230);sputc(64);serial_putc(IDnet[0]);serial_putc(IDnet[1]);serial_putc(IDnet[2]);
   serial_putc(IDnet[3]);serial_putc(IDnet[4]);serial_putc(IDnet[5]);serial_putc(IDnet[6]);
   serial_putc(IDnet[7]);serial_putc(IDnet[8]);serial_putc(IDnet[9]);serial_putc(IDnet[10]);
   serial_putc(IDnet[11]);serial_putc(IDnet[12]);sputc(26);delay (500); led= !led; digitalWrite(13, led);
   while (Wifly.available()) {comando[n]=Wifly.read(); if (comando[n]==65){AT1=1;} ++n;}
   while (AT1==0){ delay (1000);
   while (Wifly.available()) {comando[n]=Wifly.read(); if (comando[n]==65){AT1=1;} ++n;}
   sputc(222+i);sputc(202);sputc(232);sputc(64);sputc(238);sputc(64);
   sputc(230);sputc(64);serial_putc(IDnet[0]);serial_putc(IDnet[1]);serial_putc(IDnet[2]);
   serial_putc(IDnet[3]);serial_putc(IDnet[4]);serial_putc(IDnet[5]);serial_putc(IDnet[6]);
   serial_putc(IDnet[7]);serial_putc(IDnet[8]);serial_putc(IDnet[9]);serial_putc(IDnet[10]);
   serial_putc(IDnet[11]);serial_putc(IDnet[12]);sputc(26);delay (500); led= !led; digitalWrite(13, led);
                 }
    n=0;AT1=0;--i;

    sputc(223+i);sputc(202);sputc(232);sputc(64);sputc(238);sputc(64);
    sputc(224);sputc(64);serial_putc(pass[0]);serial_putc(pass[1]);serial_putc(pass[2]);
    serial_putc(pass[3]);serial_putc(pass[4]);serial_putc(pass[5]);serial_putc(pass[6]);
    serial_putc(pass[7]);serial_putc(pass[8]);serial_putc(pass[9]);serial_putc(pass[10]);
    serial_putc(pass[11]);serial_putc(pass[12]);sputc(26);delay (500); led= !led; digitalWrite(13, led);
    while (Wifly.available()) {comando[n]=Wifly.read(); if (comando[n]==65){AT1=1;} ++n;}
    while (AT1==0){ delay (1000);
     while (Wifly.available()) {comando[n]=Wifly.read(); if (comando[n]==65){AT1=1;} ++n;}
    sputc(223+i);sputc(202);sputc(232);sputc(64);sputc(238);sputc(64);
    sputc(224);sputc(64);serial_putc(pass[0]);serial_putc(pass[1]);serial_putc(pass[2]);
    serial_putc(pass[3]);serial_putc(pass[4]);serial_putc(pass[5]);serial_putc(pass[6]);
    serial_putc(pass[7]);serial_putc(pass[8]);serial_putc(pass[9]);serial_putc(pass[10]);
    serial_putc(pass[11]);serial_putc(pass[12]);sputc(26);delay(500); led= !led; digitalWrite(13, led);
                  }
    n=0;AT1=0;--i;

    sputc(224+i);sputc(202);sputc(232);sputc(64);sputc(198);sputc(222);
    sputc(218);sputc(218);sputc(64);sputc(222);sputc(224);sputc(202);
    sputc(220);sputc(64);sputc(84);sputc(166);sputc(194);sputc(220);
    sputc(170);sputc(166);sputc(132);sputc(84);sputc(26);
    delay (500); led= !led; digitalWrite(13, led);
    AT1=0;--i;

    sputc(225+i);sputc(202);sputc(232);sputc(64);sputc(198);sputc(222);
    sputc(218);sputc(218);sputc(64);sputc(228);sputc(202);sputc(218);
    sputc(222);sputc(232);sputc(202);sputc(64);sputc(84);sputc(166);
    sputc(194);sputc(220);sputc(170);sputc(166);sputc(132);sputc(84);
    sputc(26);led= !led; digitalWrite(13, led);
    delay (500);led= !led; digitalWrite(13, led);
    AT1=0;--i;

    sputc(226+i);sputc(202);sputc(232);sputc(64);sputc(210);sputc(224);
    sputc(64);sputc(224);sputc(228);sputc(222);sputc(232);sputc(222);
    sputc(64);sputc(102);sputc(26);
    delay (500); led= !led; digitalWrite(13, led);
    AT1=0;--i;

    sputc(227+i);sputc(202);sputc(232);sputc(64);sputc(210);sputc(224);
    sputc(64);sputc(216);sputc(222);sputc(198);sputc(194);sputc(216);
    sputc(64);sputc(112);sputc(96);sputc(26);
    delay (500);led= !led; digitalWrite(13, led);
    AT1=0;--i;

    sputc(228+i);sputc(194);sputc(236);sputc(202);sputc(26);
    delay (1000); led= !led; digitalWrite(13, led);
    AT1=0;--i;

     sputc(211+i);sputc(222);sputc(210);sputc(220);sputc(64);serial_putc(IDnet[0]);
     serial_putc(IDnet[1]);serial_putc(IDnet[2]);serial_putc(IDnet[3]);serial_putc(IDnet[4]);serial_putc(IDnet[5]);
     serial_putc(IDnet[6]);serial_putc(IDnet[7]);serial_putc(IDnet[8]);serial_putc(IDnet[9]);serial_putc(IDnet[10]);
     serial_putc(IDnet[11]);serial_putc(IDnet[12]);sputc(26);led= !led; digitalWrite(13, led);
     delay (4000); led= !led; digitalWrite(13, led);
     while (Wifly.available()) {comando[n]=Wifly.read(); if (comando[n]==73){AT1=1;} ++n;}
     while (AT1==0){ delay (4000);
     while (Wifly.available()) {comando[n]=Wifly.read(); if (comando[n]==73){AT1=1;} ++n;}
     sputc(211+i);sputc(222);sputc(210);sputc(220);sputc(64);serial_putc(IDnet[0]);
     serial_putc(IDnet[1]);serial_putc(IDnet[2]);serial_putc(IDnet[3]);serial_putc(IDnet[4]);serial_putc(IDnet[5]);
     serial_putc(IDnet[6]);serial_putc(IDnet[7]);serial_putc(IDnet[8]);serial_putc(IDnet[9]);serial_putc(IDnet[10]);
     serial_putc(IDnet[11]);serial_putc(IDnet[12]);sputc(26);led= !led; digitalWrite(13, led);
                    }
     n=0;AT2=0;--i;

}
